;/****************************************/;
;/* Demo Program For Graphic LCD DV12864 */;
;/* Hardware  :  ET-CPSB31 V2.0          */;
;/* Complier  :  Cross-32  V2.0          */;
;/* Function  : Show Font Thai/English   */;
;/****************************************/;
;
;/****************************/;
;/* Equate List Register CPU */;
;/****************************/;
;
P0:         EQU     080H
SP:         EQU     081H
DPL:        EQU     082H
DPH:        EQU     083H
PCON:       EQU     087H
TCON:       EQU     088H
TMOD:       EQU     089H
TL0:        EQU     08AH
TL1:        EQU     08BH
TH0:        EQU     08CH
TH1:        EQU     08DH
P1:         EQU     090H
SCON:       EQU     098H
SBUF:       EQU     099H
P2:         EQU     0A0H
IE:         EQU     0A8H
P3:         EQU     0B0H
IP:         EQU     0B8H
T2CON:      EQU     0C8H
RCAP2L:     EQU     0CAH
RCAP2H:     EQU     0CBH
TL2:        EQU     0CCH
TH2:        EQU     0CDH
PSW:        EQU     0D0H
ACC:        EQU     0E0H
B:          EQU     0F0H
;
P0.0:       EQU     080H
P0.1:       EQU     081H
P0.2:       EQU     082H
P0.3:       EQU     083H
P0.4:       EQU     084H
P0.5:       EQU     085H
P0.6:       EQU     086H
P0.7:       EQU     087H
IT0:        EQU     088H
IE0:        EQU     089H
IT1:        EQU     08AH
IE1:        EQU     08BH
TR0:        EQU     08CH
TF0:        EQU     08DH
TR1:        EQU     08EH
TF1:        EQU     08FH
P1.0:       EQU     090H
P1.1:       EQU     091H
P1.2:       EQU     092H
P1.3:       EQU     093H
P1.4:       EQU     094H
P1.5:       EQU     095H
P1.6:       EQU     096H
P1.7:       EQU     097H
RI:         EQU     098H
TI:         EQU     099H
RB8:        EQU     09AH
TB8:        EQU     09BH
REN:        EQU     09CH
SM2:        EQU     09DH
SM1:        EQU     09EH
SM0:        EQU     09FH
P2.0:       EQU     0A0H
P2.1:       EQU     0A1H
P2.2:       EQU     0A2H
P2.3:       EQU     0A3H
P2.4:       EQU     0A4H
P2.5:       EQU     0A5H
P2.6:       EQU     0A6H
P2.7:       EQU     0A7H
EX0:        EQU     0A8H
ET0:        EQU     0A9H
EX1:        EQU     0AAH
ET1:        EQU     0ABH
ES:         EQU     0ACH
ET2:        EQU     0ADH
EA:         EQU     0AFH
P3.0:       EQU     0B0H
P3.1:       EQU     0B1H
P3.2:       EQU     0B2H
P3.3:       EQU     0B3H
P3.4:       EQU     0B4H
P3.5:       EQU     0B5H
P3.6:       EQU     0B6H
P3.7:       EQU     0B7H
PX0:        EQU     0B8H
PT0:        EQU     0B9H
PX1:        EQU     0BAH
PT1:        EQU     0BBH
PS:         EQU     0BCH
PT2:        EQU     0BDH
T2CP:       EQU     0C8H
T2C:        EQU     0C9H
TR2:        EQU     0CAH
EXEN2:      EQU     0CBH
TLCK:       EQU     0CCH
RCLK:       EQU     0CDH
EXF2:       EQU     0CEH
TF2:        EQU     0CFH
P:          EQU     0D0H
OV:         EQU     0D2H
RS0:        EQU     0D3H
RS1:        EQU     0D4H
F0:         EQU     0D5H
AC:         EQU     0D6H
CY:         EQU     0D7H
ACC.0:      EQU     0E0H
ACC.1:      EQU     0E1H
ACC.2:      EQU     0E2H
ACC.3:      EQU     0E3H
ACC.4:      EQU     0E4H
ACC.5:      EQU     0E5H
ACC.6:      EQU     0E6H
ACC.7:      EQU     0E7H
B.0:        EQU     0F0H
B.1:        EQU     0F1H
B.2:        EQU     0F2H
B.3:        EQU     0F3H
B.4:        EQU     0F4H
B.5:        EQU     0F5H
B.6:        EQU     0F6H
B.7:        EQU     0F7H

;/***************************************/;
;/* Equate List Port I/O ET-CPSB31 V2.0 */;
;/***************************************/;
;
WR_COMM1:   EQU     0E0C4H                  ; Write Instruction Page1
RD_COMM1:   EQU     0E0C5H                  ; Reda Busy flag & Address Page1
WR_DATA1:   EQU     0E0C6H                  ; Write Data Page1
RD_DATA1:   EQU     0E0C7H                  ; Read Data Page1
;
WR_COMM2:   EQU     0E0C8H                  ; Write Instruction Page2
RD_COMM2:   EQU     0E0C9H                  ; Reda Busy flag & Address Page2
WR_DATA2:   EQU     0E0CAH                  ; Write Data Page2
RD_DATA2:   EQU     0E0CBH                  ; Read Data Page2

            ORG     22H                     ; Start CPU-RAM Buffer
X_ADDR1:    DFS     1                       ; X-Address1 Buffer
X_ADDR2:    DFS     1                       ; X-Address2 Buffer
Y_ADDR1:    DFS     1                       ; Y-Address1 Buffer
Y_ADDR2:    DFS     1                       ; Y-Address2 Buffer
LINE_CNT:   DFS     1                       ; Line LCD Counter
POST_CNT:   DFS     1                       ; Write LCD Position Counter

            CPU     "8051.TBL"
            HOF     "INT8"
            ORG     2200H                   ; Strat Program For "ET-DEBUG31"

MAIN:       MOV     R2,#02H                 ; Power-on Delay
PWR_DLY1:   MOV     R3,#00H
PWR_DLY2:   MOV     R4,#00H
            DJNZ    R4,$
            DJNZ    R3,PWR_DLY2
            DJNZ    R2,PWR_DLY1
            ;
            LCALL   INITGLCD                ; Initial Graphic LCD
            MOV     LINE_CNT,#8             ; Counter Line
            MOV     DPTR,#TAB_FONT          ; Table Font Thai & English
            ;
NEW_LINE:   LCALL   SET_X1                  ; Set X_Address Page1
            LCALL   SET_Y1                  ; Set Y_Address Page1
            MOV     POST_CNT,#64            ; Counter Y Position Page1
WR_PAGE1:   LCALL   BUSY_LCD1
            CLR     A
            MOVC    A,@A+DPTR               ; Get Data-Font
            PUSH    DPH
            PUSH    DPL
            MOV     DPTR,#WR_DATA1          ; Write Data Page1
            MOVX    @DPTR,A
            POP     DPL
            POP     DPH
            INC     DPTR
            DJNZ    POST_CNT,WR_PAGE1
            ;
            LCALL   SET_X2                  ; Set X_Address Page2
            LCALL   SET_Y2                  ; Set Y_Address Page2
            MOV     POST_CNT,#64            ; Counter Y Position Page2
WR_PAGE2:   LCALL   BUSY_LCD2
            CLR     A
            MOVC    A,@A+DPTR               ; Get Data-Font
            PUSH    DPH
            PUSH    DPL
            MOV     DPTR,#WR_DATA2          ; Write Data Page2
            MOVX    @DPTR,A
            POP     DPL
            POP     DPH
            INC     DPTR
            DJNZ    POST_CNT,WR_PAGE2
            ;
            INC     X_ADDR1                 ; Next Line Page1
            INC     X_ADDR2                 ; Next Line Page2
            DJNZ    LINE_CNT,NEW_LINE
            SJMP    $

;/***********************/;
;/* Initial Graphic LCD */;
;/***********************/;
;
INITGLCD:   LCALL   BUSY_LCD1               ; Wait LCD Busy
            MOV     DPTR,#WR_COMM1          ; Write Instruction1
            MOV     A,#3FH                  ; Display on-off1  X=1 ON,X=0 OFF
            MOVX    @DPTR,A
            ;
            LCALL   BUSY_LCD2               ; Wait LCD Busy
            MOV     DPTR,#WR_COMM2          ; Write Instruction2
            MOV     A,#3FH                  ; Display on-off2  X=1 ON,X=0 OFF
            MOVX    @DPTR,A
            ;
            LCALL   BUSY_LCD1               ; Wait LCD Busy
            MOV     DPTR,#WR_COMM1          ; Write Instruction1
            MOV     A,#0C0H                 ; Display Strat Page1
            MOVX    @DPTR,A
            ;
            LCALL   BUSY_LCD2               ; Wait LCD Busy
            MOV     DPTR,#WR_COMM2          ; Write Instruction2
            MOV     A,#0C0H                 ; Display Strat Page2
            MOVX    @DPTR,A
            ;
            CLR     A
            MOV     X_ADDR1,A               ; Start X-Address1 = 0
            MOV     X_ADDR2,A               ; Start X-Address2 = 0
            MOV     Y_ADDR1,A               ; Start Y-Address1 = 0
            MOV     Y_ADDR2,A               ; Start Y-Address2 = 0
            RET

;/*******************/;
;/* Set X-Address1  */;
;/* Input : X_ADDR1 */;
;/*       : (0..7)  */;
;/*******************/;
;
SET_X1:     PUSH    ACC
            LCALL   BUSY_LCD1               ; Wait LCD busy
            MOV     A,X_ADDR1
            ANL     A,#07H
            ORL     A,#0B8H
            PUSH    DPH
            PUSH    DPL
            MOV     DPTR,#WR_COMM1          ; Set X-Address Page1
            MOVX    @DPTR,A
            POP     DPL
            POP     DPH
            POP     ACC
            RET

;/*******************/;
;/* Set X-Address2  */;
;/* Input : X_ADDR2 */;
;/*       : (0..7)  */;
;/*******************/;
;
SET_X2:     PUSH    ACC
            LCALL   BUSY_LCD2               ; Wait LCD busy
            MOV     A,X_ADDR2
            ANL     A,#07H
            ORL     A,#0B8H
            PUSH    DPH
            PUSH    DPL
            MOV     DPTR,#WR_COMM2          ; Set X-Address Page2
            MOVX    @DPTR,A
            POP     DPL
            POP     DPH
            POP     ACC
            RET

;/*******************/;
;/* Set Y-Address1  */;
;/* Input : Y_ADDR1 */;
;/*       : (0..63) */;
;/*******************/;
;
SET_Y1:     PUSH    ACC
            LCALL   BUSY_LCD1       ; Wait LCD busy
            MOV     A,Y_ADDR1
            ANL     A,#63
            ORL     A,#40H
            PUSH    DPH
            PUSH    DPL
            MOV     DPTR,#WR_COMM1          ; Set Y-Address Page1
            MOVX    @DPTR,A
            POP     DPL
            POP     DPH
            POP     ACC
            RET

;/*******************/;
;/* Set Y-Address2  */;
;/* Input : Y_ADDR2 */;
;/*       : (0..63) */;
;/*******************/;
;
SET_Y2:     PUSH    ACC
            LCALL   BUSY_LCD2       ; Wait LCD busy
            MOV     A,Y_ADDR2
            ANL     A,#63
            ORL     A,#40H
            PUSH    DPH
            PUSH    DPL
            MOV     DPTR,#WR_COMM2          ; Set Y-Address Page2
            MOVX    @DPTR,A
            POP     DPL
            POP     DPH
            POP     ACC
            RET

;/***********************/;
;/* Read Busy Flag LCD1 */;
;/***********************/;
;
BUSY_LCD1:  PUSH    DPL
            PUSH    DPH
            PUSH    ACC
            MOV     DPTR,#RD_COMM1
BUSY1:      MOVX    A,@DPTR
            JB      ACC.7,BUSY1
            POP     ACC
            POP     DPH
            POP     DPL
            RET

;/***********************/;
;/* Read Busy Flag LCD2 */;
;/***********************/;
;
BUSY_LCD2:  PUSH    DPL
            PUSH    DPH
            PUSH    ACC
            MOV     DPTR,#RD_COMM2
BUSY2:      MOVX    A,@DPTR
            JB      ACC.7,BUSY2
            POP     ACC
            POP     DPH
            POP     DPL
            RET

;/****************************/;
;/* English Characters Fonts */;
;/****************************/;
;
TAB_FONT:   DFB      000H,000H,000H,000H     ; BLANK
            DFB      000H,000H,000H,000H
            DFB      000H,000H,00EH,0BFH     ; !
            DFB      00EH,000H,000H,000H
            DFB      000H,000H,007H,000H     ; "
            DFB      007H,000H,000H,000H
            DFB      000H,024H,0FFH,024H     ; #
            DFB      024H,0FFH,024H,000H
            DFB      008H,054H,054H,0FEH     ; $
            DFB      054H,054H,020H,000H
            DFB      086H,046H,020H,010H     ; %
            DFB      008H,0C4H,0C2H,000H
            DFB      060H,094H,08EH,09AH     ; &
            DFB      06EH,044H,0B0H,080H
            DFB      000H,000H,000H,005H     ; '
            DFB      003H,000H,000H,000H
            DFB      000H,000H,03CH,042H     ; (
            DFB      081H,000H,000H,000H
            DFB      000H,000H,000H,081H     ; )
            DFB      042H,03CH,000H,000H
            DFB      000H,008H,02AH,01CH     ; *
            DFB      01CH,02AH,008H,000H
            DFB      000H,008H,008H,03EH     ; +
            DFB      03EH,008H,008H,000H
            DFB      000H,000H,000H,0A0H     ; ,
            DFB      060H,000H,000H,000H
            DFB      000H,008H,008H,008H     ; -
            DFB      008H,008H,008H,000H
            DFB      000H,000H,000H,0C0H     ; .
            DFB      0C0H,000H,000H,000H
            DFB      000H,0C0H,030H,018H     ; /
            DFB      00CH,003H,000H,000H
            DFB      000H,07CH,0A2H,0B2H     ; 0
            DFB      09AH,08AH,07CH,000H
            DFB      000H,000H,082H,0FFH     ; 1
            DFB      080H,000H,000H,000H
            DFB      000H,086H,0C1H,0A1H     ; 2
            DFB      091H,089H,086H,000H
            DFB      000H,042H,081H,089H     ; 3
            DFB      089H,089H,076H,000H
            DFB      060H,050H,048H,044H     ; 4
            DFB      042H,0FFH,040H,000H
            DFB      05FH,085H,085H,085H     ; 5
            DFB      085H,049H,030H,000H
            DFB      000H,07CH,092H,089H     ; 6
            DFB      089H,089H,070H,000H
            DFB      000H,003H,001H,0C1H     ; 7
            DFB      031H,00DH,003H,000H
            DFB      000H,076H,089H,089H     ; 8
            DFB      089H,089H,076H,000H
            DFB      000H,00EH,091H,091H     ; 9
            DFB      091H,049H,03EH,000H
            DFB      000H,000H,000H,066H     ; :
            DFB      066H,000H,000H,000H
            DFB      000H,000H,080H,076H     ; ;
            DFB      036H,000H,000H,000H
            DFB      000H,000H,018H,024H     ; <
            DFB      042H,081H,000H,000H
            DFB      000H,024H,024H,024H     ; =
            DFB      024H,024H,000H,000H
            DFB      000H,000H,081H,042H     ; >
            DFB      024H,018H,000H,000H
            DFB      000H,006H,009H,00DH     ; ?
            DFB      0B5H,009H,006H,000H
            DFB      0F8H,014H,012H,011H     ; A
            DFB      012H,014H,0F8H,000H
            DFB      081H,0FFH,089H,089H     ; B
            DFB      089H,089H,076H,000H
            DFB      000H,03CH,042H,081H     ; C
            DFB      081H,081H,042H,000H
            DFB      081H,0FFH,081H,081H     ; D
            DFB      081H,042H,03CH,000H
            DFB      081H,0FFH,089H,089H     ; E
            DFB      09DH,081H,0E3H,000H
            DFB      081H,0FFH,089H,009H     ; F
            DFB      01DH,001H,003H,000H
            DFB      000H,07EH,081H,081H     ; G
            DFB      091H,051H,0F6H,000H
            DFB      000H,0FFH,008H,008H     ; H
            DFB      008H,008H,0FFH,000H
            DFB      000H,000H,081H,0FFH     ; I
            DFB      081H,000H,000H,000H
            DFB      000H,040H,080H,080H     ; J
            DFB      081H,07FH,001H,000H
            DFB      081H,0FFH,089H,014H     ; K
            DFB      022H,0C1H,081H,080H
            DFB      000H,081H,0FFH,081H     ; L
            DFB      080H,080H,0C0H,000H
            DFB      0FFH,002H,004H,018H     ; M
            DFB      004H,002H,0FFH,000H
            DFB      081H,0FFH,083H,00CH     ; N
            DFB      018H,061H,0FFH,001H
            DFB      000H,07EH,081H,081H     ; O
            DFB      081H,081H,07EH,000H
            DFB      000H,081H,0FEH,091H     ; P
            DFB      011H,011H,00EH,000H
            DFB      000H,07EH,081H,091H     ; Q
            DFB      0A1H,0C1H,07FH,080H
            DFB      081H,0FFH,089H,019H     ; R
            DFB      029H,0C9H,086H,080H
            DFB      000H,0E6H,049H,089H     ; S
            DFB      091H,092H,067H,000H
            DFB      003H,001H,081H,0FFH     ; T
            DFB      081H,001H,003H,000H
            DFB      001H,07FH,081H,080H     ; U
            DFB      080H,081H,07FH,001H
            DFB      007H,018H,060H,080H     ; V
            DFB      060H,018H,00FH,000H
            DFB      03FH,0C0H,020H,010H     ; W
            DFB      020H,0C0H,03FH,000H
            DFB      0C3H,027H,018H,018H     ; X
            DFB      018H,027H,0C3H,000H
            DFB      001H,003H,084H,0F8H     ; Y
            DFB      084H,003H,001H,000H
            DFB      0C3H,0A1H,091H,089H     ; Z
            DFB      085H,083H,0C1H,000H


;/*************************/;
;/* Thai Characters Fonts */;
;/*************************/;
;
KAI:        DFB      000H,0FAH,005H,001H
            DFB      001H,001H,0FEH,000H
KHAI:       DFB      000H,002H,005H,0FEH
            DFB      080H,07FH,000H,000H
BUFFALO:    DFB      0FEH,021H,011H,029H
            DFB      011H,001H,0FEH,000H
RAKANG:     DFB      062H,095H,0F2H,029H
            DFB      046H,080H,0FFH,000H
NGU:        DFB      000H,010H,020H,042H
            DFB      085H,0FEH,000H,000H
JAN:        DFB      002H,001H,009H,015H
            DFB      079H,081H,0FEH,000H
CHING:      DFB      012H,0E9H,0B1H,041H
            DFB      021H,0FEH,0A0H,040H
CHANG:      DFB      004H,0F2H,08AH,086H
            DFB      084H,0FAH,001H,001H
SOO:        DFB      002H,005H,002H,0FDH
            DFB      082H,07DH,000H,000H
CHER:       DFB      07AH,0A5H,041H,041H
            DFB      0A1H,07EH,040H,0FFH
YING:       DFB      07AH,0A5H,041H,001H
            DFB      0FEH,080H,080H,0FFH
YINGLOW:    DFB      000H,000H,000H,000H
            DFB      006H,006H,004H,002H
CHADA:      DFB      042H,0A5H,079H,001H
            DFB      001H,001H,0FEH,080H
CHADALOW:   DFB      000H,000H,002H,005H
            DFB      002H,005H,007H,000H
PATAK:      DFB      042H,0A5H,079H,001H
            DFB      081H,001H,0FEH,000H
PATAKLOW:   DFB      002H,005H,002H,005H
            DFB      002H,004H,007H,000H
TORTAN:     DFB      000H,002H,015H,02DH
            DFB      0F5H,085H,07AH,001H
TORTANLOW:  DFB      010H,028H,010H,028H
            DFB      014H,02AH,01EH,000H
MONTO:      DFB      002H,0E5H,012H,009H
            DFB      006H,002H,0FFH,000H
TORTHOA:    DFB      0FEH,011H,02AH,052H
            DFB      0A2H,07EH,040H,0BFH
NANE:       DFB      07AH,0A5H,041H,0FEH
            DFB      040H,0FFH,0A0H,040H
DEK:        DFB      0FEH,081H,049H,035H
            DFB      019H,001H,0FEH,000H
TORTOA:     DFB      0FEH,081H,049H,036H
            DFB      019H,001H,0FEH,000H
TUNG:       DFB      07AH,0A5H,041H,001H
            DFB      001H,001H,0FEH,000H
TAHAN:      DFB      002H,0F5H,00EH,004H
            DFB      002H,001H,0FEH,000H
TONG:       DFB      000H,002H,005H,0FDH
            DFB      085H,085H,0FAH,001H
HNOO:       DFB      002H,0F5H,08EH,040H
            DFB      020H,0FFH,0A0H,040H
BAIMAI:     DFB      002H,085H,0FEH,080H
            DFB      080H,080H,0FFH,000H
PLARHIGH:   DFB      000H,000H,000H,000H
            DFB      000H,000H,0F0H,000H
PLAR:       DFB      002H,005H,0FEH,080H
            DFB      080H,080H,0FFH,000H
PUNG:       DFB      000H,07EH,085H,042H
            DFB      040H,080H,07EH,000H
PHAHIGH:    DFB      000H,000H,000H,000H
            DFB      000H,000H,0F0H,000H
PHA:        DFB      000H,07EH,085H,042H
            DFB      040H,080H,07FH,000H
PAN:        DFB      002H,005H,0FEH,040H
            DFB      030H,040H,0FFH,000H
FUNHIGH:    DFB      000H,000H,000H,000H
            DFB      000H,000H,0F0H,000H
FUN:        DFB      002H,005H,0FEH,040H
            DFB      030H,040H,0FFH,000H
POA:        DFB      042H,0A5H,079H,001H
            DFB      001H,001H,0FEH,000H
MAR:        DFB      042H,0A5H,0FEH,020H
            DFB      020H,040H,0FFH,000H
YAK:        DFB      000H,06EH,095H,092H
            DFB      080H,080H,0FFH,000H
SHIP:       DFB      000H,002H,005H,005H
            DFB      045H,0A5H,07AH,001H
LU:         DFB      000H,07AH,0A5H,041H
            DFB      001H,001H,0FEH,000H
LULOW:      DFB      000H,000H,000H,000H
            DFB      000H,000H,00FH,000H
LING:       DFB      002H,071H,0A9H,045H
            DFB      009H,011H,0FEH,000H
WAN:        DFB      000H,002H,001H,001H
            DFB      041H,0A1H,07EH,000H
SALAHIGH:   DFB      000H,000H,000H,000H
            DFB      000H,080H,050H,020H
SALA:       DFB      07EH,081H,079H,015H
            DFB      009H,001H,0FEH,000H
RUSI:       DFB      002H,085H,0FEH,080H
            DFB      098H,090H,0FFH,010H
TIGERHIGH:  DFB      000H,000H,000H,000H
            DFB      000H,080H,050H,020H
TIGER:      DFB      002H,071H,0A9H,045H
            DFB      009H,011H,0FEH,000H
HEEP:       DFB      002H,0FDH,026H,010H
            DFB      00AH,00DH,0FAH,000H
JURAHIGH:   DFB      000H,000H,000H,000H
            DFB      040H,0A0H,0C0H,020H
JURA:       DFB      002H,0F5H,04EH,020H
            DFB      020H,040H,0FFH,000H
ANG:        DFB      000H,072H,0A9H,091H
            DFB      081H,081H,07EH,000H
HOOKHIGH:   DFB      000H,000H,000H,000H
            DFB      000H,000H,0A0H,040H
HOOK:       DFB      000H,072H,0ADH,095H
            DFB      083H,081H,07EH,000H
SARAA:      DFB      000H,066H,055H,0AAH
            DFB      088H,044H,022H,000H
TOAKUB:     DFB      000H,014H,014H,014H
            DFB      014H,014H,000H,000H
SARAAR:     DFB      000H,002H,001H,001H
            DFB      001H,001H,0FEH,000H
SARAUMHIGH: DFB      020H,050H,050H,020H
            DFB      000H,000H,000H,000H
SARAUM:     DFB      000H,002H,001H,001H
            DFB      001H,001H,0FEH,000H
SARAAA:     DFB      000H,07FH,0A0H,040H
            DFB      000H,000H,000H,000H
SARAAIR:    DFB      000H,07FH,0A0H,040H
            DFB      07FH,0A0H,040H,000H
SARAOHIGH:  DFB      010H,028H,0E8H,008H
            DFB      008H,008H,000H,000H
SARAO:      DFB      000H,000H,0FFH,0C0H
            DFB      000H,000H,000H,000H
MAIMOONHIGH: DFB      038H,034H,004H,0FCH
            DFB      000H,000H,000H,000H
MAIMOON:    DFB      000H,000H,000H,0FFH
            DFB      0C0H,000H,000H,000H
MALAIHIGH:  DFB      008H,010H,020H,010H
            DFB      0F8H,000H,000H,000H
MALAI:      DFB      000H,000H,000H,000H
            DFB      0FFH,0C0H,000H,000H
YAMOK:      DFB      000H,0F0H,0D0H,020H
            DFB      010H,010H,0F0H,000H
YAMOKLOW:   DFB      000H,000H,018H,004H
            DFB      002H,002H,001H,000H
PAIYAN:     DFB      008H,014H,010H,010H
            DFB      008H,004H,0FEH,000H
SARAUH:     DFB      000H,000H,000H,000H
            DFB      004H,00AH,03CH,000H
SARAUU:     DFB      000H,000H,000H,004H
            DFB      00AH,03CH,020H,03EH
SARAI:      DFB      000H,030H,048H,048H
            DFB      048H,050H,060H,000H
SARAE:      DFB      030H,028H,028H,028H
            DFB      038H,03CH,000H,000H
SARAAU:     DFB      000H,003H,048H,048H
            DFB      048H,050H,068H,030H
SARAAUE:    DFB      000H,030H,048H,048H
            DFB      050H,058H,060H,078H
HUN:        DFB      000H,030H,068H,050H
            DFB      040H,040H,020H,010H
NAMFON:     DFB      000H,018H,024H,024H
            DFB      014H,008H,000H,000H
TAIKU:      DFB      070H,048H,028H,028H
            DFB      048H,068H,064H,000H
MAIAKE:     DFB      000H,000H,000H,000H
            DFB      000H,070H,000H,000H
MAITO:      DFB      000H,040H,068H,058H
            DFB      040H,040H,020H,010H
MAITEE:     DFB      078H,048H,010H,018H
            DFB      008H,078H,020H,01EH
JATAWA:     DFB      000H,000H,010H,010H
            DFB      07CH,010H,010H,000H
KARAN:      DFB      000H,070H,050H,010H
            DFB      010H,00CH,000H,000H
AKEUM:      DFB      000H,030H,048H,048H
            DFB      048H,030H,006H,000H
TOUM:       DFB      002H,036H,04CH,04CH
            DFB      04AH,031H,000H,000H
TEEUM:      DFB      006H,035H,04AH,049H
            DFB      04EH,034H,002H,001H
TAWAUM:     DFB      000H,030H,048H,04AH
            DFB      04AH,037H,002H,002H
AKEHAN:     DFB      070H,050H,070H,040H
            DFB      040H,04CH,020H,010H
TOHAN:      DFB      070H,052H,076H,044H
            DFB      044H,044H,022H,011H
TEEHAN:     DFB      070H,057H,075H,042H
            DFB      041H,047H,024H,017H
TAWAHAN:    DFB      070H,050H,074H,044H
            DFB      04EH,044H,020H,010H
AKEI:       DFB      000H,060H,050H,050H
            DFB      050H,050H,066H,000H
TOI:        DFB      000H,060H,052H,056H
            DFB      054H,054H,062H,001H
TEEI:       DFB      000H,06EH,05AH,054H
            DFB      052H,05EH,068H,007H
TAWAI:      DFB      000H,060H,050H,052H
            DFB      052H,057H,062H,002H
KARANI:     DFB      000H,060H,050H,050H
            DFB      050H,05CH,06AH,001H
AKEE:       DFB      060H,050H,050H,050H
            DFB      050H,050H,07BH,000H
TOE:        DFB      060H,052H,056H,054H
            DFB      054H,052H,079H,000H
TEEE:       DFB      06EH,05AH,054H,052H
            DFB      05EH,054H,07AH,001H
TAWAE:      DFB      060H,050H,052H,052H
            DFB      057H,052H,07AH,000H

            END



