;/********************************/;
;/* Demo Program For ADC LTC1298 */;
;/* Hardware  :  ET-CPSB31 V2.0  */;
;/* Complier  :  Cross-32  V2.0  */;
;/********************************/;
;
;/****************************/;
;/* Equate List Register CPU */;
;/****************************/;
;
P0:         EQU     080H
SP:         EQU     081H
DPL:        EQU     082H
DPH:        EQU     083H
PCON:       EQU     087H
TCON:       EQU     088H
TMOD:       EQU     089H
TL0:        EQU     08AH
TL1:        EQU     08BH
TH0:        EQU     08CH
TH1:        EQU     08DH
P1:         EQU     090H
SCON:       EQU     098H
SBUF:       EQU     099H
P2:         EQU     0A0H
IE:         EQU     0A8H
P3:         EQU     0B0H
IP:         EQU     0B8H
T2CON:      EQU     0C8H
RCAP2L:     EQU     0CAH
RCAP2H:     EQU     0CBH
TL2:        EQU     0CCH
TH2:        EQU     0CDH
PSW:        EQU     0D0H
ACC:        EQU     0E0H
B:          EQU     0F0H
;
P0.0:       EQU     080H
P0.1:       EQU     081H
P0.2:       EQU     082H
P0.3:       EQU     083H
P0.4:       EQU     084H
P0.5:       EQU     085H
P0.6:       EQU     086H
P0.7:       EQU     087H
IT0:        EQU     088H
IE0:        EQU     089H
IT1:        EQU     08AH
IE1:        EQU     08BH
TR0:        EQU     08CH
TF0:        EQU     08DH
TR1:        EQU     08EH
TF1:        EQU     08FH
P1.0:       EQU     090H
P1.1:       EQU     091H
P1.2:       EQU     092H
P1.3:       EQU     093H
P1.4:       EQU     094H
P1.5:       EQU     095H
P1.6:       EQU     096H
P1.7:       EQU     097H
RI:         EQU     098H
TI:         EQU     099H
RB8:        EQU     09AH
TB8:        EQU     09BH
REN:        EQU     09CH
SM2:        EQU     09DH
SM1:        EQU     09EH
SM0:        EQU     09FH
P2.0:       EQU     0A0H
P2.1:       EQU     0A1H
P2.2:       EQU     0A2H
P2.3:       EQU     0A3H
P2.4:       EQU     0A4H
P2.5:       EQU     0A5H
P2.6:       EQU     0A6H
P2.7:       EQU     0A7H
EX0:        EQU     0A8H
ET0:        EQU     0A9H
EX1:        EQU     0AAH
ET1:        EQU     0ABH
ES:         EQU     0ACH
ET2:        EQU     0ADH
EA:         EQU     0AFH
P3.0:       EQU     0B0H
P3.1:       EQU     0B1H
P3.2:       EQU     0B2H
P3.3:       EQU     0B3H
P3.4:       EQU     0B4H
P3.5:       EQU     0B5H
P3.6:       EQU     0B6H
P3.7:       EQU     0B7H
PX0:        EQU     0B8H
PT0:        EQU     0B9H
PX1:        EQU     0BAH
PT1:        EQU     0BBH
PS:         EQU     0BCH
PT2:        EQU     0BDH
T2CP:       EQU     0C8H
T2C:        EQU     0C9H
TR2:        EQU     0CAH
EXEN2:      EQU     0CBH
TLCK:       EQU     0CCH
RCLK:       EQU     0CDH
EXF2:       EQU     0CEH
TF2:        EQU     0CFH
P:          EQU     0D0H
OV:         EQU     0D2H
RS0:        EQU     0D3H
RS1:        EQU     0D4H
F0:         EQU     0D5H
AC:         EQU     0D6H
CY:         EQU     0D7H
ACC.0:      EQU     0E0H
ACC.1:      EQU     0E1H
ACC.2:      EQU     0E2H
ACC.3:      EQU     0E3H
ACC.4:      EQU     0E4H
ACC.5:      EQU     0E5H
ACC.6:      EQU     0E6H
ACC.7:      EQU     0E7H
B.0:        EQU     0F0H
B.1:        EQU     0F1H
B.2:        EQU     0F2H
B.3:        EQU     0F3H
B.4:        EQU     0F4H
B.5:        EQU     0F5H
B.6:        EQU     0F6H
B.7:        EQU     0F7H

;/***************************************/;
;/* Equate List Port I/O ET-CPSB31 V2.0 */;
;/***************************************/;
;
CS_ADC:     EQU     P1.4                    ; Chips Select LTC1298
CS_RTC:     EQU     P1.5                    ; Chips Select DS1202
DATA_ADC:   EQU     P1.6                    ; Data I/O DS1202
CLK_ADC:    EQU     P1.7                    ; Clock DS1202

            CPU     "8051.TBL"
            HOF     "INT8"
            ORG     2200H                   ; Strat Program For "ET-DEBUG31"

MAIN:       SETB    DATA_ADC
            SETB    CLK_ADC
            SETB    CS_ADC
            CLR     CS_RTC                  ; Disable CS RTC1202
            ;
INIT_SER:   MOV     A,#0FDH                 ; Set baud rate 9600
            MOV     TH1,A
            MOV     TL1,A
            MOV     TMOD,#00100000B         ; Timer1 Mode 1
            CLR     ES                      ; Disable serial interupt
            CLR     ET1                     ; Disable timer1 interupt
            SETB    TR1                     ; Set timer1 control
            MOV     SCON,#01010000B         ; Serial mode 1
            ;
            LCALL   PRINT_SER
            DFB     0CH,"Test Read ADC 12Bit LTC1298",0DH,0AH,00H
            ;
LOOP:       LCALL   PRINT_SER
            DFB     0DH,"ADC Channal0 = ",00
            MOV     A,#00H                  ; Din Word For Ch0 Read
            LCALL   READ_ADC
            MOV     A,DPH
            LCALL   TX_2ASC
            MOV     A,DPL
            LCALL   TX_2ASC
            ;
            LCALL   PRINT_SER
            DFB     " ----  ADC Channal1 = ",00
            MOV     A,#01H                  ; Din Word For Ch1 Read
            LCALL   READ_ADC
            MOV     A,DPH
            LCALL   TX_2ASC
            MOV     A,DPL
            LCALL   TX_2ASC
            SJMP    LOOP

;*************************
;* Send 1-Byte to RS-232 *
;* Input   : ACC         *
;* Output  : Serial port *
;*************************
;
TX_BYTE:    PUSH   IE
            CLR    TI
            MOV    SBUF,A
            JNB    TI,$
            CLR    TI
            POP    IE
            RET

;****************************
;* Receive Data From RS-232 *
;* Input   :  Serial Port   *
;* Output  :  ACC           *
;****************************
;
RX_BYTE:    PUSH   IE
            JNB    RI,$                     ; Wait data
            CLR    RI
            MOV    A,SBUF
            POP    IE
            RET

;******************************
;*    Send 2 byte of ASCII    *
;*  Input : ACC (HEX)         *
;*  Example : A = A3H         *
;*          : send 41H,33H    *
;******************************
;
TX_2ASC:    LCALL   HEX_2ASC
            LCALL   TX_BYTE
            MOV     A,B
            LCALL   TX_BYTE
            RET

;******************************
;*   Convert HEX to ASCII     *
;* Input    :  A              *
;* Output   :  A (high-byte)  *
;*          :  B (low-byte)   *
;******************************
;
HEX_2ASC:   PUSH    ACC
            LCALL   HEX_TO_ASC
            MOV     B,A                     ; B = Lo byte
            POP     ACC
            SWAP    A
            LCALL   HEX_TO_ASC
            RET

;********************************
;*  Convert hex (0-F) to ASCII  *
;*  Input   : ACC (HEX code)    *
;*  Output  : ACC (ASCII code)  *
;********************************
;
HEX_TO_ASC: PUSH    PSW
            CLR     CY
            ANL     A,#00001111B
            CJNE    A,#09H,HTOA1
            SETB    CY
HTOA1:      JNB     CY,HTOA2                ;> 0AH
            ORL     A,#30H                  ;< 0AH
            SJMP    END_HTOA
HTOA2:      SUBB    A,#09H                  ;> 0AH
            ORL     A,#40H
END_HTOA:   POP     PSW
            RET

;************************************
;*  Print Data data to Serial Port  *
;*  to display buffer.              *
;*  Usage    : LCALL PRINT_SER      *
;*           : DB   'xxxx',00       *
;*  Register : ACC                  *
;*  Note     : last byte must be 00 *
;************************************
;
PRINT_SER:  POP     DPH
            POP     DPL
PRINT1:     CLR     A
            MOVC    A,@A+DPTR
            CJNE    A,#00H,PRINT2
            SJMP    PRINT3
PRINT2:     LCALL   TX_BYTE
            INC     DPTR
            SJMP    PRINT1
PRINT3:     PUSH    DPL
            PUSH    DPH
            RET

;/**********************/;
;/* Read Data From ADC */;
;/* LTC1298(12Bit A/D) */;
;/* Input  : ACC(ChXX) */;
;/* Output : DPTR      */;
;/**********************/;
; START,SGL,ODD,MSBF = ADC
;   1    1   0   X   = Ch0
;   1    1   1   X   = Ch1
; MSBF = 1 = MSB First
; MSBF = 0 = LSB First
; A = 1101 XXXX = Ch0(DF)
; A = 1111 XXXX = Ch1(FF)
;
READ_ADC:   PUSH    B
            SWAP    A               ; Swap Data
            RL      A               ; Shift User Channel to ODD
            SETB    ACC.7           ; Start Bit
            SETB    ACC.6           ; SGL = 1
            SETB    ACC.4           ; MSBF = 1 (MSB Read First)
            SETB    CLK_ADC         ; Makesure Start Clock
            SETB    DATA_ADC        ; Start Bit
            SETB    CS_ADC          ; Makesure CS=High
            CLR     CS_ADC          ; Start Operation
            ;
            MOV     B,#4            ; Counter (START/SGL/ODD/MSBF)
READ1:      RLC     A               ; Rotate Din to Carry
            CLR     CLK_ADC         ; Clock Low
            MOV     DATA_ADC,C      ; Get Data
            SETB    CLK_ADC         ; Clock High (ADC Receive Data)
            DJNZ    B,READ1         ; Loop Send Data Word 4 Bit
            ;
            SETB    DATA_ADC        ; Start for Input Read
            CLR     CLK_ADC         ; Clock Low
            MOV     B,#5            ; Counter MSB 4-Bit & Null
READ2:      MOV     C,DATA_ADC      ; Read Data
            RLC     A               ; Rotate Carry to Data
            SETB    CLK_ADC         ; Clock High
            CLR     CLK_ADC         ; Clock Low
            DJNZ    B,READ2         ; Next bit
            ANL     A,#0FH          ; Only 4bit Data  (D11..D8)
            MOV     DPH,A           ; Save Result MSB Data
            ;
            CLR     A
            MOV     B,#8            ; Counter LSB 8-bit Data
READ3:      MOV     C,DATA_ADC      ; Read Data
            RLC     A               ; Rotate Carry to Data
            SETB    CLK_ADC         ; Clock High
            CLR     CLK_ADC         ; Clock Low
            DJNZ    B,READ3         ; Next Bit
            MOV     DPL,A           ; Save Result LSB (D7..D0)
            SETB    CS_ADC          ; Stop Operation
            POP     B
            RET

            END


